--------------------------------------------------------------------------------
--
--   FileName:         dff.vhd
--   Dependencies:     None
--
--   HDL CODE IS PROVIDED "AS IS."  DIGI-KEY EXPRESSLY DISCLAIMS ANY
--   WARRANTY OF ANY KIND, WHETHER EXPRESS OR IMPLIED, INCLUDING BUT NOT
--   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
--   PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IN NO EVENT SHALL DIGI-KEY
--   BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR CONSEQUENTIAL
--   DAMAGES, LOST PROFITS OR LOST DATA, HARM TO YOUR EQUIPMENT, COST OF
--   PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ANY CLAIMS
--   BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF),
--   ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER SIMILAR COSTS.
--
--   Version History
--   Version 1.0 12/14/16 -TR
--
--------------------------------------------------------------------------------

--Basic D type flip flop w/ asynchronous reset

library IEEE;
use IEEE.std_logic_1164.all;

entity dfflop is
	port (
		clk	:	in std_logic;
		rst_n	:	in std_logic;
		D		:	in std_logic;
		Q		:	out std_logic
	);
end entity dfflop;

architecture arch of dfflop is
begin

	process(clk, rst_n)
	begin
		if(rst_n = '0') then
			Q <= '0';
		elsif(rising_edge(clk)) then
			Q <= D;
		end if;
	end process;

end architecture arch;
