--------------------------------------------------------------------------------
--
--   FileName:         full_adder.vhd
--   Dependencies:     None
--
--   HDL CODE IS PROVIDED "AS IS."  DIGI-KEY EXPRESSLY DISCLAIMS ANY
--   WARRANTY OF ANY KIND, WHETHER EXPRESS OR IMPLIED, INCLUDING BUT NOT
--   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
--   PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IN NO EVENT SHALL DIGI-KEY
--   BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR CONSEQUENTIAL
--   DAMAGES, LOST PROFITS OR LOST DATA, HARM TO YOUR EQUIPMENT, COST OF
--   PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ANY CLAIMS
--   BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF),
--   ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER SIMILAR COSTS.
--
--   Version History
--   Version 1.0 12/14/16 -TR
--
--------------------------------------------------------------------------------


--Full adder

library IEEE;
use IEEE.std_logic_1164.all;


entity full_adder is
  port (
    A     : in std_logic;
    B     : in std_logic;
    Cin   : in std_logic;
    S     : out std_logic;
    Cout  : out std_logic
  );
end entity full_adder;

architecture arch of full_adder is
begin
  S <= A xor B xor Cin;
  Cout <= (A and B) or (Cin and (A xor B));
end architecture;
